GNU bug report logs - #13718
[patch] prevents hl-line from overriding highlight-mode

Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.

Package: emacs; Reported by: Fei <fei.yuanbw@HIDDEN>; dated Fri, 15 Feb 2013 05:33:02 UTC; Maintainer for emacs is bug-gnu-emacs@HIDDEN.

Message received at 13718 <at> debbugs.gnu.org:


Received: (at 13718) by debbugs.gnu.org; 16 Feb 2013 18:57:49 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Feb 16 13:57:49 2013
Received: from localhost ([127.0.0.1]:59462 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1U6mxJ-0005Gs-3A
	for submit <at> debbugs.gnu.org; Sat, 16 Feb 2013 13:57:49 -0500
Received: from userp1040.oracle.com ([156.151.31.81]:29896)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <drew.adams@HIDDEN>) id 1U6mxG-0005Gh-1J
	for 13718 <at> debbugs.gnu.org; Sat, 16 Feb 2013 13:57:47 -0500
Received: from acsinet22.oracle.com (acsinet22.oracle.com [141.146.126.238])
	by userp1040.oracle.com (Sentrion-MTA-4.3.1/Sentrion-MTA-4.3.1) with
	ESMTP id r1GIusXq024803
	(version=TLSv1/SSLv3 cipher=DHE-RSA-AES256-SHA bits=256 verify=OK);
	Sat, 16 Feb 2013 18:56:55 GMT
Received: from acsmt358.oracle.com (acsmt358.oracle.com [141.146.40.158])
	by acsinet22.oracle.com (8.14.4+Sun/8.14.4) with ESMTP id
	r1GIuroF022580
	(version=TLSv1/SSLv3 cipher=DHE-RSA-AES256-SHA bits=256 verify=NO);
	Sat, 16 Feb 2013 18:56:54 GMT
Received: from abhmt115.oracle.com (abhmt115.oracle.com [141.146.116.67])
	by acsmt358.oracle.com (8.12.11.20060308/8.12.11) with ESMTP id
	r1GIurHQ000829; Sat, 16 Feb 2013 12:56:53 -0600
Received: from dradamslap1 (/71.202.147.44)
	by default (Oracle Beehive Gateway v4.0)
	with ESMTP ; Sat, 16 Feb 2013 10:56:53 -0800
From: "Drew Adams" <drew.adams@HIDDEN>
To: "'Fei'" <fei.yuanbw@HIDDEN>,
	"'Stefan Monnier'" <monnier@HIDDEN>
References: <CAG8JBjCsfYq8v7QyvKcjrQ=yqAJcbXcgm6fnndpPcq7MZ_GECQ@HIDDEN><jwvmwv5zijb.fsf-monnier+emacs@HIDDEN><CAG8JBjCxxomDcZLRSfnazJ0NhwER4VhncSszBWjz5wboQB4VFA@HIDDEN><jwvmwv532sm.fsf-monnier+emacs@HIDDEN><CAG8JBjD=AGoyxSrqMP=FLGc7YA7FPxFMCVYUz7e5PN7WiSYO1A@HIDDEN>
	<CAG8JBjAdcOc31CVO3xNZ965UOfoxP6CxwB56KRZ_m0GWySNyuw@HIDDEN>
Subject: RE: bug#13718: [patch] prevents hl-line from overriding highlight-mode
Date: Sat, 16 Feb 2013 10:56:46 -0800
Message-ID: <6AC7A623458E48C3B438B49FD849EDC5@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain;
	charset="us-ascii"
Content-Transfer-Encoding: 7bit
X-Mailer: Microsoft Office Outlook 11
In-Reply-To: <CAG8JBjAdcOc31CVO3xNZ965UOfoxP6CxwB56KRZ_m0GWySNyuw@HIDDEN>
Thread-Index: Ac4MdYkHXj3amcDZR4ym8pDv31LrgwAAUYFA
X-MimeOLE: Produced By Microsoft MimeOLE V6.00.2900.6157
X-Source-IP: acsinet22.oracle.com [141.146.126.238]
X-Spam-Score: -1.5 (-)
X-Debbugs-Envelope-To: 13718
Cc: 13718 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.13
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -2.8 (--)

> Or maybe there's a better solution out there -- I don't know.

code: http://www.emacswiki.org/emacs-en/download/highlight.el
doc:  http://www.emacswiki.org/HighlightLibrary





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#13718; Package emacs. Full text available.

Message received at 13718 <at> debbugs.gnu.org:


Received: (at 13718) by debbugs.gnu.org; 16 Feb 2013 18:44:27 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Feb 16 13:44:27 2013
Received: from localhost ([127.0.0.1]:59450 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1U6mkM-0004xg-AO
	for submit <at> debbugs.gnu.org; Sat, 16 Feb 2013 13:44:27 -0500
Received: from mail-qe0-f49.google.com ([209.85.128.49]:48944)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <fei.yuanbw@HIDDEN>) id 1U6mkI-0004xR-W5
	for 13718 <at> debbugs.gnu.org; Sat, 16 Feb 2013 13:44:24 -0500
Received: by mail-qe0-f49.google.com with SMTP id 5so1910505qea.36
	for <13718 <at> debbugs.gnu.org>; Sat, 16 Feb 2013 10:43:32 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20120113;
	h=mime-version:x-received:in-reply-to:references:date:message-id
	:subject:from:to:cc:content-type;
	bh=QkNB6FB/PQt8KEtiWJeF8n1TUeL/H6VXdGcJ8STRnwk=;
	b=YJn2UyBtTNzbe8jTgDVEzodPh9zD14ZnRn6pZ0EY5lXB+4oTUYvWlLhCMm8kaZPdjQ
	ax9ILdaoscTC161g/2ebRSejUPIBSQDOd528+vRGx5Fdni9aPeqqhhXne+LRCriUr6f6
	eaX4icgCQwyy2Oya+fs9YrRJzj48i6d51pQTsFGl/Nrx3sT+QqY5snXFEToPp8g/82X8
	GA269fEpUUelTK0ZmlHjjorrv/EvAA5Jo9u4Cxw0wWtKiPkm+zhY1UwuXM82JCMGSqrV
	K2RKzfAGbYBWPgTwCv9VLh4Sxnx3ktBLdCBaVQTWLwBekNFD8fLnh9h2/DEWgH+A/34/
	7RGQ==
MIME-Version: 1.0
X-Received: by 10.49.120.225 with SMTP id lf1mr2672331qeb.14.1361040212811;
	Sat, 16 Feb 2013 10:43:32 -0800 (PST)
Received: by 10.49.132.165 with HTTP; Sat, 16 Feb 2013 10:43:32 -0800 (PST)
In-Reply-To: <CAG8JBjD=AGoyxSrqMP=FLGc7YA7FPxFMCVYUz7e5PN7WiSYO1A@HIDDEN>
References: <CAG8JBjCsfYq8v7QyvKcjrQ=yqAJcbXcgm6fnndpPcq7MZ_GECQ@HIDDEN>
	<jwvmwv5zijb.fsf-monnier+emacs@HIDDEN>
	<CAG8JBjCxxomDcZLRSfnazJ0NhwER4VhncSszBWjz5wboQB4VFA@HIDDEN>
	<jwvmwv532sm.fsf-monnier+emacs@HIDDEN>
	<CAG8JBjD=AGoyxSrqMP=FLGc7YA7FPxFMCVYUz7e5PN7WiSYO1A@HIDDEN>
Date: Sat, 16 Feb 2013 13:43:32 -0500
Message-ID: <CAG8JBjAdcOc31CVO3xNZ965UOfoxP6CxwB56KRZ_m0GWySNyuw@HIDDEN>
Subject: Re: bug#13718: [patch] prevents hl-line from overriding highlight-mode
From: Fei <fei.yuanbw@HIDDEN>
To: Stefan Monnier <monnier@HIDDEN>
Content-Type: text/plain; charset=UTF-8
X-Spam-Score: 0.1 (/)
X-Debbugs-Envelope-To: 13718
Cc: 13718 <at> debbugs.gnu.org, Drew Adams <drew.adams@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.13
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: 0.1 (/)

Okay I realize this is very hackish solution, but I went ahead and
replaced every instance of font-lock-fontified with nil so that Emacs
will just use overlays for highlights at all times, which "fixed" the
problem that I have.

But a more general solution would be one of the following:

- Force highlight-regexp (and similar ones) to use overlays at all
times: I don't know why it uses two different methods to do the same
thing, but I suspect it may be for the sake of efficiency perhaps?  Or
to prevent highlights from trampling over the syntax highlighting?
Perhaps this could be made into a customizable option?

- Use font-lock for hl-line: maybe this is isn't possible because
font-lock doesn't provide the functionality to do so?

Or maybe there's a better solution out there -- I don't know.

Thanks,
Fei




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#13718; Package emacs. Full text available.

Message received at 13718 <at> debbugs.gnu.org:


Received: (at 13718) by debbugs.gnu.org; 15 Feb 2013 17:50:16 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Feb 15 12:50:16 2013
Received: from localhost ([127.0.0.1]:57934 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1U6PQO-0005qD-Ep
	for submit <at> debbugs.gnu.org; Fri, 15 Feb 2013 12:50:16 -0500
Received: from mail-qc0-f171.google.com ([209.85.216.171]:46679)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <fei.yuanbw@HIDDEN>) id 1U6PQN-0005q6-0a
	for 13718 <at> debbugs.gnu.org; Fri, 15 Feb 2013 12:50:15 -0500
Received: by mail-qc0-f171.google.com with SMTP id d1so1312570qca.30
	for <13718 <at> debbugs.gnu.org>; Fri, 15 Feb 2013 09:49:30 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20120113;
	h=mime-version:x-received:in-reply-to:references:date:message-id
	:subject:from:to:cc:content-type;
	bh=N6MhQokNXfb1EKtA1sCtTDaQfCZEB9fWp+1EhhNvxUY=;
	b=BjSmOuCyioDB39+ldEK6EHmYfcyc5vzmAOju9fshFcTKHkCQdh/BcVg+pYtfhy1xCr
	M9hkxegALN+4VWdHgrcN+0eLyiuw0GBxXhzaS/0WWAiCwN2QGf+K9fgNQ5lrHtTR6Mqo
	kUQ2nnfMyZha0k+ODQ1FUt2bs8VJPJ/hYU/UVhubtdD+wl1Re1+WOxW7By+KG7yNcdW+
	m16xC8YeClH1ZEF9tkjoG98m+Nj4R0YS3d9tH/KPvJYSvwlsTMtXphOtFrhB8kkszqUQ
	pMUC9EHY8IRR/7OmfBsAegy8wdtpLHhlr5qTKgz7AxYaKILbNeouaAAVVhcFTo264wrS
	VofA==
MIME-Version: 1.0
X-Received: by 10.49.127.101 with SMTP id nf5mr1318423qeb.20.1360950570554;
	Fri, 15 Feb 2013 09:49:30 -0800 (PST)
Received: by 10.49.132.165 with HTTP; Fri, 15 Feb 2013 09:49:30 -0800 (PST)
In-Reply-To: <jwvmwv532sm.fsf-monnier+emacs@HIDDEN>
References: <CAG8JBjCsfYq8v7QyvKcjrQ=yqAJcbXcgm6fnndpPcq7MZ_GECQ@HIDDEN>
	<jwvmwv5zijb.fsf-monnier+emacs@HIDDEN>
	<CAG8JBjCxxomDcZLRSfnazJ0NhwER4VhncSszBWjz5wboQB4VFA@HIDDEN>
	<jwvmwv532sm.fsf-monnier+emacs@HIDDEN>
Date: Fri, 15 Feb 2013 12:49:30 -0500
Message-ID: <CAG8JBjD=AGoyxSrqMP=FLGc7YA7FPxFMCVYUz7e5PN7WiSYO1A@HIDDEN>
Subject: Re: bug#13718: [patch] prevents hl-line from overriding highlight-mode
From: Fei <fei.yuanbw@HIDDEN>
To: Stefan Monnier <monnier@HIDDEN>
Content-Type: text/plain; charset=UTF-8
X-Spam-Score: 0.1 (/)
X-Debbugs-Envelope-To: 13718
Cc: 13718 <at> debbugs.gnu.org, Drew Adams <drew.adams@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.13
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -0.7 (/)

> IOW, are you sure your patch fixes the problem for you?

Oh hey, I guess it doesn't after all.  Silly me.  I guess then the
question becomes, why doesn't hi-lock use overlays?  Or conversely,
why doesn't global-hl-line-mode use font-locks?




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#13718; Package emacs. Full text available.

Message received at 13718 <at> debbugs.gnu.org:


Received: (at 13718) by debbugs.gnu.org; 15 Feb 2013 17:46:16 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Feb 15 12:46:16 2013
Received: from localhost ([127.0.0.1]:57924 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1U6PMV-0005jl-0H
	for submit <at> debbugs.gnu.org; Fri, 15 Feb 2013 12:46:15 -0500
Received: from aserp1040.oracle.com ([141.146.126.69]:27839)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <drew.adams@HIDDEN>) id 1U6PMS-0005jd-WC
	for 13718 <at> debbugs.gnu.org; Fri, 15 Feb 2013 12:46:14 -0500
Received: from ucsinet21.oracle.com (ucsinet21.oracle.com [156.151.31.93])
	by aserp1040.oracle.com (Sentrion-MTA-4.3.1/Sentrion-MTA-4.3.1) with
	ESMTP id r1FHjRuZ001756
	(version=TLSv1/SSLv3 cipher=DHE-RSA-AES256-SHA bits=256 verify=OK);
	Fri, 15 Feb 2013 17:45:28 GMT
Received: from acsmt356.oracle.com (acsmt356.oracle.com [141.146.40.156])
	by ucsinet21.oracle.com (8.14.4+Sun/8.14.4) with ESMTP id
	r1FHjQpx023425
	(version=TLSv1/SSLv3 cipher=DHE-RSA-AES256-SHA bits=256 verify=NO);
	Fri, 15 Feb 2013 17:45:26 GMT
Received: from abhmt115.oracle.com (abhmt115.oracle.com [141.146.116.67])
	by acsmt356.oracle.com (8.12.11.20060308/8.12.11) with ESMTP id
	r1FHjPKM018022; Fri, 15 Feb 2013 11:45:25 -0600
Received: from dradamslap1 (/10.159.70.147)
	by default (Oracle Beehive Gateway v4.0)
	with ESMTP ; Fri, 15 Feb 2013 09:45:25 -0800
From: "Drew Adams" <drew.adams@HIDDEN>
To: "'Stefan Monnier'" <monnier@HIDDEN>,
	"'Fei'" <fei.yuanbw@HIDDEN>
References: <CAG8JBjCsfYq8v7QyvKcjrQ=yqAJcbXcgm6fnndpPcq7MZ_GECQ@HIDDEN>
	<jwvmwv5zijb.fsf-monnier+emacs@HIDDEN>
Subject: RE: bug#13718: [patch] prevents hl-line from overriding highlight-mode
Date: Fri, 15 Feb 2013 09:45:21 -0800
Message-ID: <E83C152889224601B0D33368483D0EAE@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain;
	charset="US-ASCII"
Content-Transfer-Encoding: 7bit
X-Mailer: Microsoft Office Outlook 11
In-Reply-To: <jwvmwv5zijb.fsf-monnier+emacs@HIDDEN>
Thread-Index: Ac4LlHn8hw9ksYwPSNqeC8iBxcFh5AADWMeg
X-MimeOLE: Produced By Microsoft MimeOLE V6.00.2900.6157
X-Source-IP: ucsinet21.oracle.com [156.151.31.93]
X-Spam-Score: -1.5 (-)
X-Debbugs-Envelope-To: 13718
Cc: 13718 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.13
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -2.3 (--)

> hl-line seems to leave its overlay's priority unspecified 
> (good!), which
> means that it should take precedence over overlays which are larger
> (e.g. span multiple lines) while smaller overlays within the current
> line should take precedence over it.

Yes, that is a good _default_ behavior.  That does not mean it is the behavior
that everyone wants/needs in every context.

Being able to easily change a given overlay's priority helps users.  Being able
to do that does not mean that everyone will do it.  And the doc can of course
advise users _not_ to fiddle with overlay priorities, in general.

But hard-coding the behavior makes things harder for users.  Think default
behavior, not _the_ behavior.  Give the overlay a defvar.  Users can ignore the
variable (generally recommended) or they can change its value if needed,
globally or locally.

> I must admit to disliking explicit overlay priorities,

+1

> which tend to just lead to more problems down the road (needing
> to specify priorities on more overlays, which in turn cause yet
> more problems, ...), so if at all possible, I'd rather avoid
> doing that.

Agreed - essentially an unwinnable arms race.  Still, we should make it easy for
users to do just that: control specific overlay priorities when they need to.

Emacs has always provided more than enough rope to hang oneself.  That's part of
being "the extensible, customizable, self-documenting real-time display editor."





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#13718; Package emacs. Full text available.

Message received at 13718 <at> debbugs.gnu.org:


Received: (at 13718) by debbugs.gnu.org; 15 Feb 2013 17:31:36 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Feb 15 12:31:36 2013
Received: from localhost ([127.0.0.1]:57890 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1U6P8K-0005LX-2u
	for submit <at> debbugs.gnu.org; Fri, 15 Feb 2013 12:31:36 -0500
Received: from ironport2-out.teksavvy.com ([206.248.154.182]:32667)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <monnier@HIDDEN>) id 1U6P8I-0005LQ-DH
	for 13718 <at> debbugs.gnu.org; Fri, 15 Feb 2013 12:31:35 -0500
X-IronPort-Anti-Spam-Filtered: true
X-IronPort-Anti-Spam-Result: Av4EABK/CFFFxKjI/2dsb2JhbABEvw4Xc4IeAQEEAVYjBQsLNBIUGA0kLodwBsEtkQoDiGGcGYFegxU
X-IPAS-Result: Av4EABK/CFFFxKjI/2dsb2JhbABEvw4Xc4IeAQEEAVYjBQsLNBIUGA0kLodwBsEtkQoDiGGcGYFegxU
X-IronPort-AV: E=Sophos;i="4.84,565,1355115600"; 
   d="scan'208";a="1513903"
Received: from 69-196-168-200.dsl.teksavvy.com (HELO pastel.home)
	([69.196.168.200])
	by ironport2-out.teksavvy.com with ESMTP/TLS/ADH-AES256-SHA;
	15 Feb 2013 12:30:49 -0500
Received: by pastel.home (Postfix, from userid 20848)
	id 96F526F8CF; Fri, 15 Feb 2013 12:30:48 -0500 (EST)
From: Stefan Monnier <monnier@HIDDEN>
To: Fei <fei.yuanbw@HIDDEN>
Subject: Re: bug#13718: [patch] prevents hl-line from overriding highlight-mode
Message-ID: <jwvmwv532sm.fsf-monnier+emacs@HIDDEN>
References: <CAG8JBjCsfYq8v7QyvKcjrQ=yqAJcbXcgm6fnndpPcq7MZ_GECQ@HIDDEN>
	<jwvmwv5zijb.fsf-monnier+emacs@HIDDEN>
	<CAG8JBjCxxomDcZLRSfnazJ0NhwER4VhncSszBWjz5wboQB4VFA@HIDDEN>
Date: Fri, 15 Feb 2013 12:30:48 -0500
In-Reply-To: <CAG8JBjCxxomDcZLRSfnazJ0NhwER4VhncSszBWjz5wboQB4VFA@HIDDEN>
	(Fei's message of "Fri, 15 Feb 2013 11:15:10 -0500")
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/24.3.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 13718
Cc: 13718 <at> debbugs.gnu.org, Drew Adams <drew.adams@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.13
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -1.9 (-)

>> hl-line seems to leave its overlay's priority unspecified (good!), which
>> means that it should take precedence over overlays which are larger
>> (e.g. span multiple lines) while smaller overlays within the current
>> line should take precedence over it.

> That's actually a reasonable alternative to my hard-coded solution,
> but the problem is that it doesn't seem to work in every case: when I
> open a file that has syntax highlighting (e.g. Bash or Python) and
> then use highlight-phrase/regexp, the global-hl-line will have higher
> priority than the highlight, no matter what the size of the highlight
> is.  If I do the same thing in text-mode, the problem does not occur.
> (This was tested on 24.2.1-i386-mingw-nt6.1.7601  without any custom
> configuration.)

That's a different issue: in most major modes, font-lock will be enable,
in which case hi-lock uses it, which implies that hi-lock will use
text-properties instead of overlays.  And text-properties always have
lower priority than overlays.
Problem is: in such a case, not only you do have a problem, but your
patch should make no difference, so overlays always take priority over
text-properties, no matter the value of the `priority' property.

IOW, are you sure your patch fixes the problem for you?


        Stefan




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#13718; Package emacs. Full text available.

Message received at 13718 <at> debbugs.gnu.org:


Received: (at 13718) by debbugs.gnu.org; 15 Feb 2013 16:15:58 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Feb 15 11:15:58 2013
Received: from localhost ([127.0.0.1]:57823 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1U6Nx8-0003Ze-9Y
	for submit <at> debbugs.gnu.org; Fri, 15 Feb 2013 11:15:58 -0500
Received: from mail-ee0-f42.google.com ([74.125.83.42]:42462)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <fei.yuanbw@HIDDEN>) id 1U6Nx4-0003ZT-RS
	for 13718 <at> debbugs.gnu.org; Fri, 15 Feb 2013 11:15:56 -0500
Received: by mail-ee0-f42.google.com with SMTP id b47so1855645eek.29
	for <13718 <at> debbugs.gnu.org>; Fri, 15 Feb 2013 08:15:10 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
	d=googlemail.com; s=20120113;
	h=mime-version:x-received:in-reply-to:references:date:message-id
	:subject:from:to:cc:content-type;
	bh=RorfjT2APFXJ60hhhat+91eAMPVX4tPbYSCUUDNmb9A=;
	b=bJXZ2XaIEWTRNtoiC6ePKiMAr7OGaSzIMc2mu1EQWh0p/R1pfBjsMdyz4/F/LT/dwO
	V7T0D79UzIzwJxH1xrHUE5sFZrrNAa3h4cEdQNTBRnES2XpEwDn8OYr9yOc0Zi2oUX7G
	P8BZ3YpnFpEu0WtkP0iFEjJIhGT3ULxfw55VaUF3upYKVRDT/h7cvAt45yXp6FM82SPg
	SPs57OezhKm8Q6Pt/57Gxnmh+4cu/LouUuOGDC1SD16WBLHY+1pIwmZclEQ9thtqyQxT
	Wcg69B9V6WD/D0OVPQTJD/59XL1ZV/hdy/FNgadKxg9EcX6OmyT8RhHnJy9HBYxMCw+b
	Kd3Q==
MIME-Version: 1.0
X-Received: by 10.14.4.69 with SMTP id 45mr10068731eei.0.1360944910326; Fri,
	15 Feb 2013 08:15:10 -0800 (PST)
Received: by 10.14.130.10 with HTTP; Fri, 15 Feb 2013 08:15:10 -0800 (PST)
In-Reply-To: <jwvmwv5zijb.fsf-monnier+emacs@HIDDEN>
References: <CAG8JBjCsfYq8v7QyvKcjrQ=yqAJcbXcgm6fnndpPcq7MZ_GECQ@HIDDEN>
	<jwvmwv5zijb.fsf-monnier+emacs@HIDDEN>
Date: Fri, 15 Feb 2013 11:15:10 -0500
Message-ID: <CAG8JBjCxxomDcZLRSfnazJ0NhwER4VhncSszBWjz5wboQB4VFA@HIDDEN>
Subject: Re: bug#13718: [patch] prevents hl-line from overriding highlight-mode
From: Fei <fei.yuanbw@HIDDEN>
To: Stefan Monnier <monnier@HIDDEN>,
	Drew Adams <drew.adams@HIDDEN>
Content-Type: text/plain; charset=UTF-8
X-Spam-Score: 0.1 (/)
X-Debbugs-Envelope-To: 13718
Cc: 13718 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.13
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -0.7 (/)

> hl-line seems to leave its overlay's priority unspecified (good!), which
> means that it should take precedence over overlays which are larger
> (e.g. span multiple lines) while smaller overlays within the current
> line should take precedence over it.
>
> Can you describe your particular case?  What are the overlays that
> "disappear", what do they cover, and why do you think they should not
> "disappear" like that?

That's actually a reasonable alternative to my hard-coded solution,
but the problem is that it doesn't seem to work in every case: when I
open a file that has syntax highlighting (e.g. Bash or Python) and
then use highlight-phrase/regexp, the global-hl-line will have higher
priority than the highlight, no matter what the size of the highlight
is.  If I do the same thing in text-mode, the problem does not occur.
(This was tested on 24.2.1-i386-mingw-nt6.1.7601  without any custom
configuration.)

> The priority here should be a user option, or at least a defvar that a user can
> tweak.  Likewise, for other overlay priorities in Emacs.

That's fine too, as long as it can be changed without directly messing
with the internals.  Currently there is no such variable available for
either hl-line or any of the highlights.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#13718; Package emacs. Full text available.

Message received at 13718 <at> debbugs.gnu.org:


Received: (at 13718) by debbugs.gnu.org; 15 Feb 2013 15:52:21 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Feb 15 10:52:21 2013
Received: from localhost ([127.0.0.1]:57818 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1U6NaG-000345-UV
	for submit <at> debbugs.gnu.org; Fri, 15 Feb 2013 10:52:21 -0500
Received: from relais.videotron.ca ([24.201.245.36]:46451)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <monnier@HIDDEN>) id 1U6NaF-00033z-LI
	for 13718 <at> debbugs.gnu.org; Fri, 15 Feb 2013 10:52:20 -0500
MIME-version: 1.0
Content-transfer-encoding: 7BIT
Content-type: text/plain; CHARSET=US-ASCII
Received: from ceviche.home ([24.201.208.110]) by VL-VM-MR006.ip.videotron.ca
	(Oracle Communications Messaging Exchange Server 7u4-22.01 64bit
	(built Apr 21
	2011)) with ESMTP id <0MI9001U1QQ0TJ10@HIDDEN> for
	13718 <at> debbugs.gnu.org; Fri, 15 Feb 2013 10:51:36 -0500 (EST)
Received: by ceviche.home (Postfix, from userid 20848)	id D073166109; Fri,
	15 Feb 2013 10:51:35 -0500 (EST)
From: Stefan Monnier <monnier@HIDDEN>
To: Fei <fei.yuanbw@HIDDEN>
Subject: Re: bug#13718: [patch] prevents hl-line from overriding highlight-mode
Message-id: <jwvmwv5zijb.fsf-monnier+emacs@HIDDEN>
References: <CAG8JBjCsfYq8v7QyvKcjrQ=yqAJcbXcgm6fnndpPcq7MZ_GECQ@HIDDEN>
Date: Fri, 15 Feb 2013 10:51:35 -0500
In-reply-to: <CAG8JBjCsfYq8v7QyvKcjrQ=yqAJcbXcgm6fnndpPcq7MZ_GECQ@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/24.3.50 (gnu/linux)
X-Spam-Score: 1.6 (+)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
	has
	identified this incoming email as possible spam. The original message
	has been attached to this so you can view it (if it isn't spam) or
	label similar future email.  If you have any questions, see
	the administrator of that system for details.
	Content preview: > I found that the overlays in highlight-mode do not
	override the > overlays from global-hl-line-mode,
	causing them to disappear on the
	> currently active line. hl-line seems to leave its overlay's priority
	unspecified (good!),
	which means that it should take precedence over overlays which are
	larger (e.g. span multiple lines) while smaller overlays within the
	current line should take precedence over it. [...] 
	Content analysis details:   (1.6 points, 10.0 required)
	pts rule name              description
	---- ----------------------
	--------------------------------------------------
	-0.0 RCVD_IN_DNSWL_NONE RBL: Sender listed at http://www.dnswl.org/,
	no trust [24.201.245.36 listed in list.dnswl.org]
	0.7 SPF_SOFTFAIL SPF: sender does not match SPF record (softfail)
	0.8 BAYES_50               BODY: Bayes spam probability is 40 to 60%
	[score: 0.4398]
	0.1 HDRS_LCASE             Odd capitalization of message header
	0.0 T_MANY_HDRS_LCASE Odd capitalization of multiple message headers
X-Debbugs-Envelope-To: 13718
Cc: 13718 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.13
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: 0.2 (/)

> I found that the overlays in highlight-mode do not override the
> overlays from global-hl-line-mode, causing them to disappear on the
> currently active line.

hl-line seems to leave its overlay's priority unspecified (good!), which
means that it should take precedence over overlays which are larger
(e.g. span multiple lines) while smaller overlays within the current
line should take precedence over it.

Can you describe your particular case?  What are the overlays that
"disappear", what do they cover, and why do you think they should not
"disappear" like that?

> The solution I found was to edit hi-lock.el to
> increase the priority of the overlay, as outlined in this patch:

I must admit to disliking explicit overlay priorities, which tend to
just lead to more problems down the road (needing to specify priorities
on more overlays, which in turn cause yet more problems, ...), so if at
all possible, I'd rather avoid doing that.


        Stefan




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#13718; Package emacs. Full text available.

Message received at 13718 <at> debbugs.gnu.org:


Received: (at 13718) by debbugs.gnu.org; 15 Feb 2013 15:27:43 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Feb 15 10:27:43 2013
Received: from localhost ([127.0.0.1]:57792 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1U6NCQ-0002Sq-5a
	for submit <at> debbugs.gnu.org; Fri, 15 Feb 2013 10:27:42 -0500
Received: from userp1040.oracle.com ([156.151.31.81]:47612)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <drew.adams@HIDDEN>) id 1U6NCM-0002Sh-Dx
	for 13718 <at> debbugs.gnu.org; Fri, 15 Feb 2013 10:27:40 -0500
Received: from acsinet22.oracle.com (acsinet22.oracle.com [141.146.126.238])
	by userp1040.oracle.com (Sentrion-MTA-4.3.1/Sentrion-MTA-4.3.1) with
	ESMTP id r1FFQrsg001739
	(version=TLSv1/SSLv3 cipher=DHE-RSA-AES256-SHA bits=256 verify=OK);
	Fri, 15 Feb 2013 15:26:54 GMT
Received: from acsmt357.oracle.com (acsmt357.oracle.com [141.146.40.157])
	by acsinet22.oracle.com (8.14.4+Sun/8.14.4) with ESMTP id
	r1FFQrIg012345
	(version=TLSv1/SSLv3 cipher=DHE-RSA-AES256-SHA bits=256 verify=NO);
	Fri, 15 Feb 2013 15:26:53 GMT
Received: from abhmt105.oracle.com (abhmt105.oracle.com [141.146.116.57])
	by acsmt357.oracle.com (8.12.11.20060308/8.12.11) with ESMTP id
	r1FFQr7E031280; Fri, 15 Feb 2013 09:26:53 -0600
Received: from dradamslap1 (/10.159.70.147)
	by default (Oracle Beehive Gateway v4.0)
	with ESMTP ; Fri, 15 Feb 2013 07:26:52 -0800
From: "Drew Adams" <drew.adams@HIDDEN>
To: "'Fei'" <fei.yuanbw@HIDDEN>, <13718 <at> debbugs.gnu.org>
References: <CAG8JBjCsfYq8v7QyvKcjrQ=yqAJcbXcgm6fnndpPcq7MZ_GECQ@HIDDEN>
Subject: RE: bug#13718: [patch] prevents hl-line from overriding highlight-mode
Date: Fri, 15 Feb 2013 07:26:48 -0800
Message-ID: <270B6FAA5E034F46945C3E7CC1A7DD3C@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain;
	charset="US-ASCII"
Content-Transfer-Encoding: 7bit
X-Mailer: Microsoft Office Outlook 11
In-Reply-To: <CAG8JBjCsfYq8v7QyvKcjrQ=yqAJcbXcgm6fnndpPcq7MZ_GECQ@HIDDEN>
Thread-Index: Ac4LPdtFhg30kcMPTqKiRZ+MO27K7AAUqM2g
X-MimeOLE: Produced By Microsoft MimeOLE V6.00.2900.6157
X-Source-IP: acsinet22.oracle.com [141.146.126.238]
X-Spam-Score: -1.5 (-)
X-Debbugs-Envelope-To: 13718
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.13
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -1.5 (-)

> I found that the overlays in highlight-mode do not override the
> overlays from global-hl-line-mode, causing them to disappear on the
> currently active line.  The solution I found was to edit hi-lock.el to
> increase the priority of the overlay, as outlined in this patch:

Bad design.

The priority here should be a user option, or at least a defvar that a user can
tweak.  Likewise, for other overlay priorities in Emacs.

A library can reasonably set the _default_ priority for an overlay, but it
cannot know what priority might actually be most appropriate when the library is
used in combination with other code and when taking user preferences into
account.





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#13718; Package emacs. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 15 Feb 2013 05:32:12 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Feb 15 00:32:12 2013
Received: from localhost ([127.0.0.1]:56969 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1U6Du7-00031m-Ju
	for submit <at> debbugs.gnu.org; Fri, 15 Feb 2013 00:32:12 -0500
Received: from eggs.gnu.org ([208.118.235.92]:58944)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <fei.yuanbw@HIDDEN>) id 1U6CvW-0001cU-00
	for submit <at> debbugs.gnu.org; Thu, 14 Feb 2013 23:29:34 -0500
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
	(envelope-from <fei.yuanbw@HIDDEN>) id 1U6Cul-0006bJ-Vc
	for submit <at> debbugs.gnu.org; Thu, 14 Feb 2013 23:28:53 -0500
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=-2.6 required=5.0 tests=BAYES_00,FREEMAIL_FROM,
	RCVD_IN_DNSWL_LOW,T_DKIM_INVALID autolearn=unavailable version=3.3.2
Received: from lists.gnu.org ([208.118.235.17]:33390)
	by eggs.gnu.org with esmtp (Exim 4.71)
	(envelope-from <fei.yuanbw@HIDDEN>) id 1U6Cul-0006bA-Sj
	for submit <at> debbugs.gnu.org; Thu, 14 Feb 2013 23:28:47 -0500
Received: from eggs.gnu.org ([208.118.235.92]:42043)
	by lists.gnu.org with esmtp (Exim 4.71)
	(envelope-from <fei.yuanbw@HIDDEN>) id 1U6Cuf-0000tP-UM
	for bug-gnu-emacs@HIDDEN; Thu, 14 Feb 2013 23:28:47 -0500
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
	(envelope-from <fei.yuanbw@HIDDEN>) id 1U6Cuc-0006Y2-AH
	for bug-gnu-emacs@HIDDEN; Thu, 14 Feb 2013 23:28:41 -0500
Received: from mail-qc0-f170.google.com ([209.85.216.170]:60947)
	by eggs.gnu.org with esmtp (Exim 4.71)
	(envelope-from <fei.yuanbw@HIDDEN>) id 1U6Cuc-0006Xl-2W
	for bug-gnu-emacs@HIDDEN; Thu, 14 Feb 2013 23:28:38 -0500
Received: by mail-qc0-f170.google.com with SMTP id d42so1164127qca.29
	for <bug-gnu-emacs@HIDDEN>; Thu, 14 Feb 2013 20:28:37 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20120113;
	h=mime-version:x-received:date:message-id:subject:from:to
	:content-type; bh=gozy6w14zdkHZL/iM5O6K2dIBmMrBJBi6xx7KXxRGkw=;
	b=yikl/QWqTQ0yJaTq40abDKW7vkOiM0R0MnYjSIdZxYESLIuWn46Xx3PGUge3uiz9L8
	S4TsYYFZ5G8nNDUPIK8XDT2Pu3tbQl4N0rhHEPWr9ugr93fsT0RIQ2v4jZVp7R3Z/foB
	lt1fdM06Tp2xdp9luNHGZEkLTVX10dJR2aXnCa0aeXoIKzKXGg5ewoRGaV08X93ZRrpl
	biiwmsUToo53c3TtBPKK6Oc2XJQOFJZF04sf0Jy/oxNxw+Y3A3r2jbz3qfZMpiciudKf
	3ORabHodcXMVxBqNe/KhVgehiWDKLZlWahBLsi+Dd7MKJNodZQ0k+HPe+krb7ri5i1OB
	EhPA==
MIME-Version: 1.0
X-Received: by 10.229.136.78 with SMTP id q14mr110466qct.74.1360902517223;
	Thu, 14 Feb 2013 20:28:37 -0800 (PST)
Received: by 10.49.132.165 with HTTP; Thu, 14 Feb 2013 20:28:37 -0800 (PST)
Date: Thu, 14 Feb 2013 23:28:37 -0500
Message-ID: <CAG8JBjCsfYq8v7QyvKcjrQ=yqAJcbXcgm6fnndpPcq7MZ_GECQ@HIDDEN>
Subject: [patch] prevents hl-line from overriding highlight-mode
From: Fei <fei.yuanbw@HIDDEN>
To: bug-gnu-emacs@HIDDEN
Content-Type: text/plain; charset=UTF-8
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 3.x [fuzzy]
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.6.x
X-Received-From: 208.118.235.17
X-Spam-Score: -3.4 (---)
X-Debbugs-Envelope-To: submit
X-Mailman-Approved-At: Fri, 15 Feb 2013 00:32:09 -0500
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.13
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -6.1 (------)

Hello,

I found that the overlays in highlight-mode do not override the
overlays from global-hl-line-mode, causing them to disappear on the
currently active line.  The solution I found was to edit hi-lock.el to
increase the priority of the overlay, as outlined in this patch:

--- hi-lock.el 2012-08-28 19:40:24.000000000 -0400
+++ hi-lock.el 2013-02-14 12:57:56.715031100 -0500
@@ -591,6 +591,7 @@
             (goto-char search-start)
             (while (re-search-forward regexp search-end t)
               (let ((overlay (make-overlay (match-beginning 0) (match-end 0))))
+                (overlay-put overlay 'priority 1)
                 (overlay-put overlay 'hi-lock-overlay t)
                 (overlay-put overlay 'hi-lock-overlay-regexp serial)
                 (overlay-put overlay 'face face))

My Emacs version is: 24.2.1 (i386-mingw-nt6.1.7601) 2012-08-28 on MARVIN

Thanks,
Fei




Acknowledgement sent to Fei <fei.yuanbw@HIDDEN>:
New bug report received and forwarded. Copy sent to bug-gnu-emacs@HIDDEN. Full text available.
Report forwarded to bug-gnu-emacs@HIDDEN:
bug#13718; Package emacs. Full text available.
Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.
Last modified: Fri, 31 Oct 2014 17:00:04 UTC

GNU bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997 nCipher Corporation Ltd, 1994-97 Ian Jackson.